<!DOCTYPE html>
<html xmlns:th="http://www.thymeleaf.org">
<head>
  <meta http-equiv="Content-Type" charset="UTF-8">
  <title>Films</title>
  <link th:href="@{'https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css'}" rel="stylesheet">
  <link th:href="@{'https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-star-rating@4.1.2/css/star-rating.min.css'}" media="all" rel="stylesheet" type="text/css"/>
  <script th:src="@{'https://unpkg.com/@popperjs/core@2'}"></script>
  <link rel="stylesheet" th:href="@{'https://use.fontawesome.com/releases/v5.7.2/css/all.css'}" crossorigin="anonymous">
  <script th:src="@{'https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.min.js'}"></script>
  <script th:src="@{/jquery-3.6.0.js}"></script>
  <script th:src="@{/rater.js}"></script>
  <link rel="stylesheet" th:href="@{'https://cdn.jsdelivr.net/npm/bootstrap-select@1.14.0-beta3/dist/css/bootstrap-select.min.css'}">
  <script th:src="@{'https://cdn.jsdelivr.net/npm/bootstrap-select@1.14.0-beta3/dist/js/bootstrap-select.min.js'}"></script>

</head>
<body>
<div th:insert="~{/navbar::content}"></div>

<div class="container-fluid">

  <h1>Films List</h1>
  <button type="button" class="btn btn-outline-primary" data-bs-toggle="modal"
          data-bs-target="#addModal">
    Add film
  </button>
  <div class="row">
    <div class="col-12">
      <div class="table-responsive">
        <table class="table table-striped align-middle">
          <thead>
          <tr>
            <th class="text-center">Id</th>
            <th class="text-center">Title</th>
            <th class="text-center">Description</th>
            <th class="text-center">Category</th>
            <th class="text-center">Release year</th>
            <th class="text-center">Rate</th>
            <th class="text-center">Length</th>
            <th class="text-center">Replacement cost</th>
            <th class="text-center">Actions</th>
          </tr>
          </thead>
          <tbody>
          <tr th:each="film : ${films.getContent()}">
            <td class="text-center" th:text="${film.filmId}"></td>
            <td class="text-center" th:text="${film.title}"></td>
            <td class="text-center" th:text="${film.description}"></td>
            <td class="text-center" th:text="${film.getCategories()}"></td>
            <td class="text-center" th:text="${film.releaseYear}"></td>
            <td>
              <div class="rating" th:attr="data-rate-value=${film.rentalRate}"></div>
            </td>
            <td class="text-center" th:text="${film.filmLength}"></td>
            <td class="text-center" th:text="${film.replacementCost}"></td>
            <td style="width: 130px">
              <button type="button" class="btn btn-sm btn-success fa fa-eye noUnderlineCustom text-white" data-bs-toggle="modal"
                      th:attr="data-bs-target=${'#showModal'+film.filmId}" data-row="${film}"></button>
              <button type="button" class="btn btn-sm btn-primary fas fa-pencil-alt noUnderlineCustom text-white" data-bs-toggle="modal"
                      th:attr="data-bs-target=${'#editModal'+film.filmId}" data-row="${film}"></button>
              <button type="button" class="btn btn-sm btn-danger fas fa-solid fa-trash noUnderlineCustom text-white" data-bs-toggle="modal"
                      th:attr="data-bs-target=${'#deleteModal'+film.filmId}" data-row="${film}"></button>
            </td>

          </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</div>
<!--Modal show-->
<div class="modal fade" th:each="row : ${films.getContent()}" th:attr="id=${'showModal' + row.filmId}" tabindex="-1" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="sModalLabel">Film details</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <div class="mb-3">
          <label class="form-label" style="font-weight: bold" th:text="'Title: '"></label>
          <span th:text="${row.title}"></span>
        </div>
        <div class="mb-3">
          <label class="form-label" style="font-weight: bold" th:text="'Description: '"></label>
          <span th:text="${row.description}"></span>
        </div>
        <div class="mb-3">
          <label class="form-label" style="font-weight: bold" th:text="'Category: '"></label>
          <span th:utext="${row.getCategories()}"></span>
        </div>
        <div class="mb-3">
          <label class="form-label" style="font-weight: bold" th:text="'Actors: '"></label>
          <span th:utext="${row.getActors()}"></span>
        </div>
        <div class="mb-3">
          <label class="form-label" style="font-weight: bold" th:text="'Release year: '"></label>
          <span th:text="${row.releaseYear}"></span>
        </div>
        <div class="mb-3">
          <label class="form-label" style="font-weight: bold" th:text="'Rental duration: '"></label>
          <span th:text="${row.rentalDuration}"></span>
        </div>
        <div class="mb-3">
          <label class="form-label" style="font-weight: bold" th:text="'Rental rate: '"></label>
          <div class="rating" th:attr="data-rate-value=${row.rentalRate}"></div>
        </div>
        <div class="mb-3">
          <label class="form-label" style="font-weight: bold" th:text="'Length: '"></label>
          <span th:text="${row.filmLength}"></span>
        </div>
        <div class="mb-3">
          <label class="form-label" style="font-weight: bold" th:text="'Replacement cost: '"></label>
          <span th:text="${row.replacementCost}"></span>
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
      </div>
    </div>
  </div>
</div>

<!--Modal edit-->
<div class="modal fade" th:each="row : ${films.getContent()}" th:attr="id=${'editModal' + row.filmId}" tabindex="-1" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="eModalLabel">Update film</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <form th:action="@{/film/update}" method="post">
        <input hidden="hidden" name="filmId" th:value="${row.filmId}">
        <div class="modal-body">
          <div class="mb-3">
            <label for="filmTitleId" class="form-label" th:text="'Input film title: '"></label>
            <input type="text" class="form-control" id="filmTitleId" name="title" th:value="${row.title}">
          </div>
          <div class="mb-3">
            <label for="filmDescriptionId" class="form-label" th:text="'Input film description: '"></label>
            <input type="text" class="form-control" id="filmDescriptionId" name="description" th:value="${row.description}">
          </div>
          <div class="mb-3">
            <label for="select-category1" class="form-label" th:text="'Category: '"></label>
            <select id="select-category1" class="selectpicker" multiple name="categoryIds">
              <option th:each="category : ${categories}"
                      th:value="${category.categoryId}"
                      th:text="${category.name}"
                      th:selected="${row.getCategoryIds().contains(category.getCategoryId())}"></option>
            </select>
          </div>
          <div class="mb-3">
            <label for="select-actor1" class="form-label" th:text="'Actor: '"></label>
            <select id="select-actor1" class="selectpicker" multiple name="actorIds">
              <option th:each="actor : ${actors}"
                      th:value="${actor.actorId}"
                      th:text="${actor.firstName + ' ' + actor.getLastName()}"
                      th:selected="${row.getActorIds().contains(actor.getActorId())}"></option>
            </select>
          </div>
          <div class="mb-3">
            <label for="filmReleaseYearId" class="form-label" th:text="'Input film release year: '"></label>
            <input type="text" class="form-control" id="filmReleaseYearId" name="releaseYear" th:value="${row.releaseYear}">
          </div>
          <div class="mb-3">
            <label for="filmRentalDurationId" class="form-label" th:text="'Input film rental duration: '"></label>
            <input type="text" class="form-control" id="filmRentalDurationId" name="rentalDuration" th:value="${row.rentalDuration}">
          </div>
          <div class="mb-3">
            <label for="filmRentalRateId" class="form-label" th:text="'Input film rental rate: '"></label>
            <input type="text" class="form-control" id="filmRentalRateId" name="rentalRate" th:value="${row.rentalRate}">
          </div>
          <div class="mb-3">
            <label for="filmLengthId1" class="form-label" th:text="'Input film film length: '"></label>
            <input type="text" class="form-control" id="filmLengthId1" name="filmLength" th:value="${row.filmLength}">
          </div>
          <div class="mb-3">
            <label for="filmReplacementCostId" class="form-label" th:text="'Input film replacement cost: '"></label>
            <input type="text" class="form-control" id="filmReplacementCostId" name="replacementCost" th:value="${row.replacementCost}">
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
          <button type="submit" class="btn btn-primary">Save changes</button>
        </div>
      </form>
    </div>
  </div>
</div>

<!--Modal delete-->
<div class="modal fade" th:each="row : ${films.getContent()}" th:attr="id=${'deleteModal' + row.filmId}" tabindex="-1" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="dModalLabel" th:text="'Delete film: ' + ${row.title}"></h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <form th:action="@{/film/delete}" method="post">
        <div class="modal-body">
          <input hidden="hidden" name="filmId" th:value="${row.filmId}">
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
          <button type="submit" class="btn btn-danger">Delete</button>
        </div>
      </form>
    </div>
  </div>
</div>



<div th:if="${films.getTotalPages() > 1}">
  <div class="row col-sm-12">
    <div class="col-sm-2">
      Total Rows: [[${films.getTotalElements()}]]
    </div>
    <div class="col-sm-10">
                    <span th:each="i: ${#numbers.sequence(1, films.getTotalPages())}">
      <a th:if="${films.getNumber()  != i -1 }" th:href="@{'/film/list?page=' + ${i - 1}}">[[${i}]]</a>
      <span th:unless="${films.getNumber()   != i -1 }">[[${i}]]</span> &nbsp; &nbsp;
                    </span>
    </div>
  </div>
</div>
</div>

<!--Modal add-->
<div class="modal fade" id="addModal" tabindex="-1" aria-labelledby="addModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="addModalLabel">Add film</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <form th:action="@{/film/add}" method="post">
        <div class="modal-body">
          <div class="mb-3">
            <label for="titleId" class="form-label" th:text="'Title: '"></label>
            <input type="text" class="form-control" id="titleId" name="title">
          </div>
          <div class="mb-3">
            <label for="descriptionId" class="form-label" th:text="'Description: '"></label>
            <input type="text" class="form-control" id="descriptionId" name="description">
          </div>
          <div class="mb-3">
            <label for="select-category" class="form-label" th:text="'Category: '"></label>
            <select id="select-category" class="selectpicker" multiple name="categoryIds">
              <option th:each="category : ${categories}"
                      th:value="${category.categoryId}"
                      th:text="${category.name}"></option>
            </select>
          </div>
          <div class="mb-3">
            <label for="select-actor" class="form-label" th:text="'Actor: '"></label>
            <select id="select-actor" class="selectpicker" multiple name="actorIds">
              <option th:each="actor : ${actors}"
                      th:value="${actor.actorId}"
                      th:text="${actor.firstName + ' ' + actor.getLastName()}"></option>
            </select>
          </div>
          <div class="mb-3">
            <label for="releaseYearId" class="form-label" th:text="'ReleaseYear: '"></label>
            <input type="text" class="form-control" id="releaseYearId" name="releaseYear">
          </div>
          <div class="mb-3">
            <label for="rentalDurationId" class="form-label" th:text="'Rental duration: '"></label>
            <input type="text" class="form-control" id="rentalDurationId" name="rentalDuration">
          </div>
          <div class="mb-3">
            <label for="rentalRateId" class="form-label" th:text="'Rental rate: '"></label>
            <input type="text" class="form-control" id="rentalRateId" name="rentalRate">
          </div>
          <div class="mb-3">
            <label for="filmLengthId" class="form-label" th:text="'Film length: '"></label>
            <input type="text" class="form-control" id="filmLengthId" name="filmLength">
          </div>
          <div class="mb-3">
            <label for="replacementCostId" class="form-label" th:text="'Replacement cost: '"></label>
            <input type="text" class="form-control" id="replacementCostId" name="replacementCost">
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
          <button type="submit" class="btn btn-primary">Save changes</button>
        </div>
      </form>
    </div>
  </div>
</div>
<script>
    $(document).ready(function () {
        let options = {
            max_value: 5,
            step_size: 0.1,
            initial_value: 0,
            selected_symbol_type: 'utf8_star',
            cursor: 'default',
            readonly: true,
            change_once: true
        }

        $(".rating").rate(options);

    });

</script>
</body>

</html>
